package com.ejie.ad74a.util.constantes;

import java.util.Locale;

import org.springframework.context.i18n.LocaleContextHolder;

import com.ejie.ad74a.model.Combo;
import com.ejie.ad74a.util.comun.Utilidades;

/**
 * Estados de un expediente
 */

public enum TipoMotivoRetrasoEnum {

	ILOCALIZABLE("1", "motivoRetraso.ilocalizable"), //
	AUSENTE("2", "motivoRetraso.ausente"), //
	NO_RESPONDE("3", "motivoRetraso.no_responde"), //
	OTROS("4", "motivoRetraso.otros"), //
	INCIDENCIA_PRESTADOR("5", "motivoRetraso.incidencia_prestador");

	private TipoMotivoRetrasoEnum(String id, String labelDesc) {
		this.labelDesc = labelDesc;
		this.id = id;
	}

	private String id;
	private String labelDesc;

	public String getId() {
		return this.id;
	}

	public String getLabelDesc() {
		return Utilidades.getLabelFromResource(Constantes.BASENAME_RESOURCE_AD74A_I18N, this.labelDesc,
				LocaleContextHolder.getLocale());
	}

	public String getLabelDesc(Locale locale) {
		return Utilidades.getLabelFromResource(Constantes.BASENAME_RESOURCE_AD74A_I18N, this.labelDesc, locale);
	}

	public Combo getCombo() {
		return new Combo(id.toString(),
				Utilidades.getLabelFromResource(Constantes.BASENAME_RESOURCE_AD74A_I18N, this.labelDesc,
						com.ejie.ad74a.constantes.Constantes.LOCALE_ES),
				Utilidades.getLabelFromResource(Constantes.BASENAME_RESOURCE_AD74A_I18N, this.labelDesc,
						com.ejie.ad74a.constantes.Constantes.LOCALE_EU));
	}

	public static TipoMotivoRetrasoEnum getById(String id) {
		for (TipoMotivoRetrasoEnum e : values()) {
			if (e.id.equals(id))
				return e;
		}
		return null;
	}

	public static String getDesc(String id) {
		for (TipoMotivoRetrasoEnum proc : TipoMotivoRetrasoEnum.values()) {
			if (proc.getId().equals(id)) {
				return proc.getLabelDesc();
			}
		}
		return null;
	}

}
